# frozen_string_literal: true
module Hyrax
  class SearchBuilder < ::SearchBuilder
    self.default_processor_chain += [:filter_tombstone]

    def filter_tombstone(solr_parameters)
      if current_user.nil?
        solr_parameters[:fq] <<  "{!terms f=is_tombstoned_ssim}false"
      else

        return if current_user.crc_manager?

        if current_user.crc_group_manager? && solr_parameters['q'].present?
          solr_parameters[:fq] <<  "{!terms f=is_tombstoned_ssim}false"
        elsif current_user.crc_group_manager?
          solr_parameters[:fq] <<  "-tombstone_status_ssim:deleted"
        else
          solr_parameters[:fq] <<  "{!terms f=is_tombstoned_ssim}false"
        end
      end
    end
  end
end